## [10.0.0] - 2025-01-25

### Added

- SystemProtection
  - New resource to configure System Protection settings (formerly xWindowsRestore) - Fixes [Issue #364](https://github.com/dsccommunity/ComputerManagementDsc/issues/364).
- SystemRestorePoint
  - New resource to create and delete restore points (formerly xSystemRestorePoint) - Fixes [Issue #364](https://github.com/dsccommunity/ComputerManagementDsc/issues/364).
- ScheduledTask
  - Added support for ScheduleType 'OnIdle', 'AtCreation', 'OnSessionState'.
    Fixes [Issue #282](https://github.com/dsccommunity/ComputerManagementDsc/issues/282).
  - Added support for StateChange to allow specifying which session state changes should
    trigger the task (with ScheduleType = OnSessionState).
  - Added support for StopAtDurationEnd permitting control over the 'Stop all running tasks
    at the end of the repetition duration' feature.
    Fixes [Issue #168](https://github.com/dsccommunity/ComputerManagementDsc/issues/168).
  - Added support for TriggerExecutionTimeLimit permitting control over per-trigger 'Stop task
    if it runs longer than...' feature.

### Fixed

- BREAKING CHANGE: ScheduledTask
  - Fixed SynchronizeAcrossTimeZone issue where Test always throws False when a date & time is used
    where Daylight Savings Time is in operation. Fixes [Issue #374](https://github.com/dsccommunity/ComputerManagementDsc/issues/374).
  - Fixed Test-DateStringContainsTimeZone to correctly process date strings behind UTC (-), as well
    as UTC Zulu 'Z' strings.
  - Fixed User parameter to correctly return the user that triggers an AtLogon or OnSessionState
    Schedule Type, instead of the current value of ExecuteAsCredential. This parameter
    is only valid when using the AtLogon and OnSessionState Schedule Types.
  - Fixed User parameter to permit use even if LogonType = Group.
  - Updated RandomDelay logic from a blacklist to a whitelist.
  - Updated Delay parameter logic to reflect other TimeSpan based values.
  - Updated unit tests to use Should -Invoke for Pester 5 compatibility.
  - Updated various parameters with requirements in documentation.
- `VirtualMemory` fix incorrect variable name
- `SmbServerConfiguration` remove errant argument
- Update all calls to edit the registry so that the value Type is explicitly set.
  Fixes [Issue #433](https://github.com/dsccommunity/ComputerManagementDsc/issues/433).
- Made AppVeyor use ModuleFast to resolve dependencies.

### Changed

- BREAKING CHANGE: ScheduledTask
  - StartTime has chnage the type from DateTime to String.
  - StartTime is now processed on the device, rather than at compile time. This makes it possible
    to configure start times based on each device's timezone, rather than being fixed to the time zone
    configured on the device where the Desired State Configuration compilation was run.
  - Allow StartTime to be used to set the 'Activate' setting when adding ScheduleType triggers
    other than 'Once', 'Daily' and 'Weekly'.
  - Changed the default StartTime date from today to 1st January 1980 to prevent configuration flip flopping,
    and added note to configuration README to advise always supplying a date, and not just a time.
    Fixes [Issue #148](https://github.com/dsccommunity/ComputerManagementDsc/issues/148).
    Fixes [Issue #411](https://github.com/dsccommunity/ComputerManagementDsc/issues/411).
  - Added examples & note to configuration README to supply a timezone when using SynchronizeAcrossTimeZone.
  - Allow SynchronizeAcrossTimeZone to be used when adding ScheduleType triggers other than 'Once',
    'Daily' and 'Weekly'.
  - Updated Delay parameter to support ScheduleType AtLogon, AtStartup, AtCreation, OnSessionState.
    Fixes [Issue #345](https://github.com/dsccommunity/ComputerManagementDsc/issues/345).
  - Updated User parameter for use with ScheduleType OnSessionState in addition to AtLogon.
  - Updated integration tests to ensure resource and configuration names are matching.
- Converted tests to Pester 5
- Rename Delete-ADSIObject to Delete-ADSIObject to satisfy HQRM
- No longer uses alias `New-InvalidArgumentException` but instead `New-ArgumentException`

### Removed

- Removed `Get-InvalidOperationRecord` to use version provided by `DscResource.Test`


